import { LitElement as c, unsafeCSS as u, html as l, nothing as f } from "lit";
import { property as n, state as v } from "lit/decorators.js";
import { FormControlMixin as b } from "@open-wc/form-control";
import { event as p } from "../../utils/event.js";
import { groupRequiredValidator as x } from "../../utils/validators.js";
import "../label/index.js";
const y = `:host {
  display: inline-block;
  width: fit-content;
  outline: none;

  --dfx-checkbox-group-direction: column;
  --dfx-checkbox-group-gap: var(--dfx-size-2xs, 0.5rem);
}

:host([hidden]) {
  display: none;
}

:host([disabled]) dfx-label {
  opacity: var(--dfx-form-disabled-opacity, 0.5);
}

fieldset {
  border: none;
  padding: 0;
  margin: 0;
}

legend {
  padding: 0;
  margin-bottom: var(--dfx-checkbox-group-gap);
}

[part='container'] {
  display: flex;
  flex-wrap: wrap;
  flex-direction: var(--dfx-checkbox-group-direction);
  gap: var(--dfx-checkbox-group-gap) calc(var(--dfx-checkbox-group-gap) * 2);
}

dfx-label[type='error'],
dfx-label[type='helper'] {
  margin-top: var(--dfx-checkbox-group-gap);
}
`;
var g = Object.defineProperty, m = Object.getOwnPropertyDescriptor, t = (o, e, a, s) => {
  for (var i = s > 1 ? void 0 : s ? m(e, a) : e, d = o.length - 1, h; d >= 0; d--)
    (h = o[d]) && (i = (s ? h(e, a, i) : h(i)) || i);
  return s && i && g(e, a, i), i;
};
class r extends b(c) {
  constructor() {
    super(...arguments), this.value = null, this.required = !1, this.disabled = !1, this.dirty = !1;
  }
  static {
    this.styles = u(y);
  }
  static {
    this.formControlValidators = [x];
  }
  connectedCallback() {
    super.connectedCallback(), this.addEventListener("focus", this.#t), this.addEventListener("invalid", this.#r);
  }
  disconnectedCallback() {
    super.disconnectedCallback(), this.removeEventListener("focus", this.#t), this.removeEventListener("invalid", this.#r);
  }
  #e() {
    return [...this.querySelectorAll("dfx-checkbox")];
  }
  #i() {
    return this.#e().filter((e) => e.checked);
  }
  #n() {
    return this.#i().map((e) => e.value);
  }
  #t(e) {
    e.relatedTarget !== this.#e()[0] && this.#e()[0]?.focus();
  }
  #r() {
    this.dirty = !0;
  }
  #a(e) {
    this.dirty = !0, this.value = this.#n().join(",") || null, this.onChange.emit(this.value), e.stopPropagation();
  }
  validityCallback() {
    return this.onInvalid.emit(this.internals.validity), this.validationMessage;
  }
  async updated(e) {
    (e.has("value") || e.has("required")) && (this.setValue(this.value), await this.validationComplete, this.requestUpdate()), e.has("disabled") && this.#e().forEach((a) => a.disabled = this.disabled);
  }
  resetFormControl() {
    this.dirty = !1, this.value = this.getAttribute("value") || null;
  }
  firstUpdated() {
    this.tabIndex = 0, this.#e().forEach((e) => {
      this.value?.split(",").includes(e.value) ? e.setAttribute("checked", "") : e.removeAttribute("checked");
    });
  }
  #l() {
    return l`<legend><dfx-label>${this.label}</dfx-label></legend>`;
  }
  #s() {
    return l`<dfx-label type="error">${this.validationMessage}</dfx-label>`;
  }
  #o() {
    return this.helperText ? l`<dfx-label type="helper">${this.helperText}</dfx-label>` : l``;
  }
  /** @ignore */
  get #d() {
    return !this.validity.valid && this.dirty;
  }
  render() {
    return l`
      <fieldset part="fieldset">
        ${this.label ? this.#l() : f}
        <div part="container" @dfx-change=${this.#a}>
          <slot></slot>
        </div>
        ${this.#d ? this.#s() : this.#o()}
      </fieldset>
    `;
  }
}
t([
  n({ type: String, reflect: !0 })
], r.prototype, "label", 2);
t([
  n({ type: String })
], r.prototype, "value", 2);
t([
  n({ type: String, reflect: !0 })
], r.prototype, "name", 2);
t([
  n({ type: Boolean, reflect: !0 })
], r.prototype, "required", 2);
t([
  n({ type: Boolean, reflect: !0 })
], r.prototype, "disabled", 2);
t([
  n({ type: String, attribute: "helper-text", reflect: !0 })
], r.prototype, "helperText", 2);
t([
  p("dfx-change")
], r.prototype, "onChange", 2);
t([
  p("dfx-invalid")
], r.prototype, "onInvalid", 2);
t([
  v()
], r.prototype, "dirty", 2);
export {
  r as CheckboxGroup
};
//# sourceMappingURL=checkbox-group.js.map
