import { LitElement as f, unsafeCSS as c, html as a, nothing as v } from "lit";
import { property as s, state as p } from "lit/decorators.js";
import { FormControlMixin as x } from "@open-wc/form-control";
import { event as u } from "../../utils/event.js";
import { groupRequiredValidator as y } from "../../utils/validators.js";
import "../label/index.js";
const g = `:host {
  display: inline-block;
  width: fit-content;
  outline: none;

  --dfx-radio-group-direction: column;
  --dfx-radio-group-gap: var(--dfx-size-2xs, 0.5rem);
}

:host([hidden]) {
  display: none;
}

:host([disabled]) dfx-label {
  opacity: var(--dfx-form-disabled-opacity, 0.5);
}

fieldset {
  border: none;
  padding: 0;
  margin: 0;
}

legend {
  padding: 0;
  margin-bottom: var(--dfx-radio-group-gap);
}

[part='container'] {
  display: flex;
  flex-wrap: wrap;
  flex-direction: var(--dfx-radio-group-direction);
  gap: var(--dfx-radio-group-gap) calc(var(--dfx-radio-group-gap) * 2);
}

dfx-label[type='error'],
dfx-label[type='helper'] {
  margin-top: var(--dfx-radio-group-gap);
}
`;
var b = Object.defineProperty, m = Object.getOwnPropertyDescriptor, t = (l, e, r, o) => {
  for (var n = o > 1 ? void 0 : o ? m(e, r) : e, d = l.length - 1, h; d >= 0; d--)
    (h = l[d]) && (n = (o ? h(e, r, n) : h(n)) || n);
  return o && n && b(e, r, n), n;
};
class i extends x(f) {
  constructor() {
    super(...arguments), this.value = null, this.required = !1, this.disabled = !1, this.dirty = !1, this.focusedOptionIndex = 0;
  }
  static {
    this.styles = c(g);
  }
  static {
    this.formControlValidators = [y];
  }
  connectedCallback() {
    super.connectedCallback(), this.#l(), this.addEventListener("focus", this.#n), this.addEventListener("invalid", this.#s), this.addEventListener("keydown", this.#a);
  }
  disconnectedCallback() {
    super.disconnectedCallback(), this.removeEventListener("focus", this.#n), this.removeEventListener("invalid", this.#s), this.removeEventListener("keydown", this.#a);
  }
  #t() {
    return [...this.querySelectorAll("dfx-radio")];
  }
  #d() {
    return this.#t().filter((e) => e.checked);
  }
  #r() {
    return this.#d().map((e) => e.value);
  }
  #e() {
    return this.#t().filter((e) => !e.disabled);
  }
  #i() {
    return this.#e()[this.focusedOptionIndex];
  }
  #n(e) {
    e.relatedTarget !== this.#i() && this.#i()?.focus();
  }
  #s() {
    this.dirty = !0;
  }
  #a(e) {
    if (["ArrowDown", "ArrowRight"].includes(e.key))
      this.focusedOptionIndex++;
    else if (["ArrowUp", "ArrowLeft"].includes(e.key))
      this.focusedOptionIndex--;
    else
      return;
    this.focusedOptionIndex < 0 ? this.focusedOptionIndex = this.#e().length - 1 : this.focusedOptionIndex > this.#e().length - 1 && (this.focusedOptionIndex = 0), this.#i() && (this.#i().focus(), this.#o(this.#i().value), this.value = this.#r().join(",") || null), e.preventDefault();
  }
  #h(e) {
    this.dirty = !0, e.detail && (this.#o(e.target.value), this.focusedOptionIndex = this.#e().indexOf(e.target)), this.value = this.#r().join(",") || null, this.onChange.emit(this.value), e.stopPropagation();
  }
  #o(e) {
    this.#t().forEach((r) => r.checked = r.value === e);
  }
  #l() {
    this.focusedOptionIndex = this.value && this.#e().length ? this.#e().indexOf(
      this.#e().filter((e) => e.value === this.value)[0]
    ) : 0;
  }
  validityCallback() {
    return this.onInvalid.emit(this.internals.validity), this.validationMessage;
  }
  async updated(e) {
    (e.has("value") || e.has("required")) && (this.setValue(this.value), await this.validationComplete, this.requestUpdate()), e.has("disabled") && this.#t().forEach((r) => r.disabled = this.disabled);
  }
  resetFormControl() {
    this.dirty = !1, this.value = this.getAttribute("value") || null, this.#l();
  }
  firstUpdated() {
    this.tabIndex = 0, this.#t().forEach((e) => {
      this.value?.split(",").includes(e.value) ? e.setAttribute("checked", "") : e.removeAttribute("checked");
    });
  }
  #p() {
    return a`<legend><dfx-label>${this.label}</dfx-label></legend>`;
  }
  #u() {
    return a`<dfx-label type="error">${this.validationMessage}</dfx-label>`;
  }
  #f() {
    return this.helperText ? a`<dfx-label type="helper">${this.helperText}</dfx-label>` : a``;
  }
  /** @ignore */
  get #c() {
    return !this.validity.valid && this.dirty;
  }
  render() {
    return a`
      <fieldset part="fieldset">
        ${this.label ? this.#p() : v}
        <div part="container" @dfx-change=${this.#h}>
          <slot></slot>
        </div>
        ${this.#c ? this.#u() : this.#f()}
      </fieldset>
    `;
  }
}
t([
  s({ type: String, reflect: !0 })
], i.prototype, "label", 2);
t([
  s({ type: String })
], i.prototype, "value", 2);
t([
  s({ type: String, reflect: !0 })
], i.prototype, "name", 2);
t([
  s({ type: Boolean, reflect: !0 })
], i.prototype, "required", 2);
t([
  s({ type: Boolean, reflect: !0 })
], i.prototype, "disabled", 2);
t([
  s({ type: String, attribute: "helper-text", reflect: !0 })
], i.prototype, "helperText", 2);
t([
  u("dfx-change")
], i.prototype, "onChange", 2);
t([
  u("dfx-invalid")
], i.prototype, "onInvalid", 2);
t([
  p()
], i.prototype, "dirty", 2);
t([
  p()
], i.prototype, "focusedOptionIndex", 2);
export {
  i as RadioGroup
};
//# sourceMappingURL=radio-group.js.map
