import { LitElement as c, unsafeCSS as p, html as h, nothing as f } from "lit";
import { query as x, property as o } from "lit/decorators.js";
import { live as b } from "lit/directives/live.js";
import { FormControlMixin as u } from "@open-wc/form-control";
import { event as v } from "../../utils/event.js";
import "../label/index.js";
const m = `:host {
  display: inline-block;

  --dfx-radio-border-radius: var(--dfx-border-radius-full, 62.438rem);
  --dfx-radio-color: var(--dfx-color-primary-dark, #0063eb);
  --dfx-radio-focus-offset: var(--dfx-form-outline-offset, 0.2rem);
  --dfx-radio-font-family: var(
    --dfx-font-family,
    -apple-system,
    BlinkMacSystemFont,
    'Segoe UI',
    Roboto,
    Arial,
    sans-serif
  );
  --dfx-radio-font-size: var(--dfx-font-size-m, 0.875rem);
  --dfx-radio-gap: var(--dfx-size-2xs, 0.5rem);
  --dfx-radio-line-height: var(--dfx-line-height-m, 1.5);
  --dfx-radio-size: var(--dfx-size-l, 1.25rem);
  --dfx-radio-transition: all var(--dfx-transition-medium, 0.2s ease-in-out);
}

:host([hidden]) {
  display: none;
}

:host([disabled]) input {
  box-shadow: inset 0 0 0 calc(var(--dfx-size-xs, 0.75rem) / 2)
    var(--dfx-color-border-dark, #979fab);
  cursor: not-allowed;

  &:not(:checked) {
    --dfx-radio-color: var(--dfx-color-border-dark, #979fab);
    background-color: var(--dfx-radio-color);
  }
}

:host([disabled]) [part='label'] {
  opacity: var(--dfx-form-disabled-opacity, 0.5);
}

label {
  display: grid;
  grid-template-columns: auto 1fr;
  gap: var(--dfx-radio-gap);
}

input {
  display: inline-block;
  width: var(--dfx-radio-size);
  height: var(--dfx-radio-size);
  box-sizing: border-box;
  background-color: transparent;
  appearance: none;
  box-shadow: var(--dfx-form-border, inset 0 0 0 0.0625rem #979fab);
  transition: var(--dfx-radio-transition);
  border-radius: var(--dfx-radio-border-radius);
  cursor: pointer;
  border: none;
  margin: 0;

  &:checked {
    box-shadow: inset 0 0 0 calc(var(--dfx-size-xs, 0.75rem) / 2) var(--dfx-radio-color);
  }

  &:focus-visible {
    outline: auto;
    outline-offset: var(--dfx-radio-focus-offset);
  }
}

[part='label'] {
  font-family: var(--dfx-radio-font-family);
  font-size: var(--dfx-radio-font-size);
  line-height: var(--dfx-radio-line-height);
}
`;
var y = Object.defineProperty, g = Object.getOwnPropertyDescriptor, n = (i, e, d, a) => {
  for (var r = a > 1 ? void 0 : a ? g(e, d) : e, s = i.length - 1, l; s >= 0; s--)
    (l = i[s]) && (r = (a ? l(e, d, r) : l(r)) || r);
  return a && r && y(e, d, r), r;
};
class t extends u(c) {
  constructor() {
    super(...arguments), this.checked = !1, this.disabled = !1;
  }
  static {
    this.styles = p(m);
  }
  #e(e) {
    this.checked = e.target.checked, this.onChange.emit(this.checked, { bubbles: !0 });
  }
  updated(e) {
    (e.has("value") || e.has("checked")) && this.setValue(this.checked ? this.value : null);
  }
  resetFormControl() {
    this.checked = this.hasAttribute("checked");
  }
  focus() {
    this.validationTarget.tabIndex = 0, this.validationTarget.focus();
  }
  blur() {
    this.validationTarget.tabIndex = -1;
  }
  #r() {
    return h`<dfx-label type="helper" id="label">${this.helperText}</dfx-label>`;
  }
  render() {
    return h`<label part="container">
      <input
        part="input"
        type="radio"
        autocomplete="off"
        tabindex="-1"
        .checked=${b(this.checked)}
        value=${this.value ?? f}
        ?disabled=${this.disabled}
        @blur=${this.blur}
        @change=${this.#e}
        aria-describedby=${this.helperText ? "label" : f}
      />
      <div part="label">
        <slot></slot>
        ${this.helperText ? this.#r() : f}
      </div>
    </label>`;
  }
}
n([
  x("input")
], t.prototype, "validationTarget", 2);
n([
  o({ type: Boolean })
], t.prototype, "checked", 2);
n([
  o({ type: String })
], t.prototype, "value", 2);
n([
  o({ type: Boolean, reflect: !0 })
], t.prototype, "disabled", 2);
n([
  o({ type: String, attribute: "helper-text", reflect: !0 })
], t.prototype, "helperText", 2);
n([
  v("dfx-change")
], t.prototype, "onChange", 2);
export {
  t as Radio
};
//# sourceMappingURL=radio.js.map
