export interface EventOptions {
    bubbles?: boolean;
    cancelable?: boolean;
    composed?: boolean;
}
/**
 * Event property class, emits custom event of specified type
 */
export declare class EventEmitter<T> {
    private target;
    private eventName;
    constructor(target: HTMLElement, eventName: string);
    emit(value: T, options?: EventOptions): void;
}
/**
 * Event decorator, creates event property
 * @param name Name of event
 */
export declare function event(name: string): (target: unknown, propName: string) => void;
//# sourceMappingURL=event.d.ts.map